# Tweaks for Windows

Tools for managing Windows setting

* [`hvswitch`.cmd](https://git.hmp.today/pavel.muhortov/tweaks-for-windows#hvswitch-cmd)
* [`rdpusers`.cmd](https://git.hmp.today/pavel.muhortov/tweaks-for-windows#rdpusers-cmd)
* [`1cibases`.cmd](https://git.hmp.today/pavel.muhortov/tweaks-for-windows#1cibases-cmd)
* [`dfs-set-active`.ps1](https://git.hmp.today/pavel.muhortov/tweaks-for-windows#dfs-set-active-ps1)

____

## `hvswitch`.cmd

**Description:**
> Microsoft Hyper-V switch on/off

**Dependencies:**
>
> * Windows (tested version 10.0.19043)

|  POSITION | PARAMETERS   |       DESCRIPTION      |    DEFAULT    |
|-----------|--------------|------------------------|---------------|
|     1     |   **[qn]**   |execution without pauses|     `None`    |
|     2     |    **[y]**   |enable Hyper-V, if it off|    `None`    |
|     2     |    **[n]**   |disable Hyper-V, if it on|    `None`    |

Example usage in terminal:

```cmd
.\hvswitch.cmd qn y
```

____

## `rdpusers`.cmd

**Description:**
> RDS Shadow Connection

**Dependencies:**
>
> * Windows (tested version 6.3.9600)
> * permission on target hostname (*gpedit.msc -> Computer Configuration -> Policies -> Administrative Templates -> Windows components -> Remote Desktop Services -> Remote Session Host -> Connections -> Set rules for remote control of Remote Desktop Services user sessions: Full Control without users's permission*)

|  POSITION | PARAMETERS   |       DESCRIPTION      |    DEFAULT    |
|-----------|--------------|------------------------|---------------|
|     1     |  **[host]**  |hostname or address with sessions for connect|`None`|

Example usage in terminal:

```cmd
.\rdpusers.cmd ts.domain.local
```

____

## `1cibases`.cmd

**Description:**
> 1CEStart backup/restore settings

**Dependencies:**
>
> * Windows (tested version 6.3.9600)
> * privileged rights (only for backup)

|  POSITION | PARAMETERS   |       DESCRIPTION      |    DEFAULT    |
|-----------|--------------|------------------------|---------------|
|     1     |    **[qn]**  |execution without pauses|     `None`    |
|     2     |    **[b]**   |restore                 |     `None`    |
|     2     |    **[r]**   |backup                  |     `None`    |

### `1cibases`.cmd setup

1\. Create and edit `%SYSTEMDRIVE%\Users\Default\AppData\Roaming\1C\1CEStart\ibases.v8i` manually or by backup your settings running ```.\1cibases.cmd qn b``` as Administrator. New user profiles will have this `ibases.v8i`.

2\. Only if you need to rewrite user changes at their logon:
>
> * Create `%SYSTEMDRIVE%\Windows\System32\GroupPolicy\User\Scripts\Logon\1cibases.cmd`
> * gpedit.msc -> User Configuration -> Administrative Templates -> System -> Logon -> Run these programs at user logon: `%SYSTEMDRIVE%\Windows\System32\GroupPolicy\User\Scripts\Logon\1cibases.cmd qn r`.

____

## `dfs-set-active`.ps1

**Description:**
> Set active server for used DFS namespaces.

**Dependencies:**
>
> * Windows (tested versions 6.1.7601, 10.0.19045, 10.0.22621)
> * privileged rights

|  POSITION | PARAMETERS   |       DESCRIPTION      |    DEFAULT    |
|-----------|--------------|------------------------|---------------|
|     1     |  **-child**  |internal execute switch |    `false`    |

### `dfs-set-active`.ps1 setup

1\. Create config file.

```powershell
@"
\\domain.local\dfs_namespace_1\share_dir_1:\\server_1.domain.local\share_dir_1
\\domain.local\dfs_namespace_2\share_dir_2:\\server_2.domain.local\share_dir_2
"@ | Out-File $env:\Windows\System32\GroupPolicy\Machine\Scripts\Startup\dfs-set-active.cfg -Encoding "UTF8"
```

2\. Create startup script.

gpedit.msc -> Computer Settings -> Policies -> Windows Settings -> Scripts (Startup/Shutdown) -> Startup -> PowerShell Scripts: `%SYSTEMDRIVE%\Windows\System32\GroupPolicy\Machine\Scripts\Startup\dfs-set-active.ps1`.
